import requests
import json

location = "<your_location_id>"             # enter your location id
authtoken = "<your_authorization_token>"     # enter your auth token

outfile = 'beacons.json'                    # the file that is saved
api_call = 1
beacons_datab = []

meridian_url = "https://edit.meridianapps.com/api/locations/"
locations_api = "https://edit.meridianapps.com/api/locations/" + str(location)
beacons_api = locations_api + "/beacons?page_size=200"   # can optionally add ?page_size=1##

payload = ""
headers = {
    'Content-Type': "application/x-www-form-urlencoded",
    'Authorization': "Token" + str(authtoken),
    'cache-control': "no-cache"
    }

location_info = requests.get(locations_api, headers=headers)
loc_parsed = location_info.json()
print("Location Name:", loc_parsed['name'])
print("Here is the Beacon data API:", beacons_api)


def get_beacons():
    global api_call
    print("API GET round #", api_call)
    response = requests.request("GET", beacons_api, data=payload, headers=headers)
    global jparse
    jparse = response.json()
    global beacons_data
    beacons_data = jparse['results']
    beacons_datab.extend(beacons_data)
    print("Beacons processed so far:",len(beacons_datab))
    api_call += 1
    check_for_more()


def write_beacon_file():
    # write beacons info to the beacons.json file
    with open(outfile, 'w') as f:
        json.dump(beacons_datab, f)
    print("Writing the data to",f.name)
    f.close()
    print("File written and closed!")
    # bring the contents of beacons.json back to beaconlist
    with open(outfile, 'r') as r:
        beaconlist = json.load(r)
    r.close()
    print("Beacons in the file:",len(beaconlist))
    print("We're done here!")
    exit()


def check_for_more():
    if str(jparse['next']) != 'None':
        print("Next Page", jparse['next'])
        global beacons_api
        beacons_api = jparse['next']
        get_beacons()
    else:
        print("Data has been sucked!")
        write_beacon_file()


get_beacons()
